package id.durianpay.dpay_flutter;


import org.json.JSONException;
import org.json.JSONObject;

import id.durianpay.android.model.DCheckoutOptions;

public class CheckoutMapper {
    //map function to set the checkout options in Durianpay
    public static void map(JSONObject options, DCheckoutOptions checkoutOptions) {
        try {
            if (options.get("environment") != JSONObject.NULL)
                checkoutOptions.setEnvironment(String.valueOf(options.get("environment")));
            if (options.get("locale") != JSONObject.NULL)
                checkoutOptions.setLocale(String.valueOf(options.get("locale")));
            if (options.get("siteName") != JSONObject.NULL)
                checkoutOptions.setSiteName(String.valueOf(options.get("siteName")));
            if (options.get("customerId") != JSONObject.NULL)
                checkoutOptions.setCustomerId(String.valueOf(options.get("customerId")));
            if (options.get("customerGivenName") != JSONObject.NULL)
                checkoutOptions.setCustomerGivenName(String.valueOf(options.get("customerGivenName")));
            if (options.get("customerEmail") != JSONObject.NULL)
                checkoutOptions.setCustomerEmail(String.valueOf(options.get("customerEmail")));
            if (options.get("orderId") != JSONObject.NULL)
                checkoutOptions.setOrderId(String.valueOf(options.get("orderId")));
            if (options.get("accessToken") != JSONObject.NULL)
                checkoutOptions.setAccessToken(String.valueOf(options.get("accessToken")));

            if (options.get("payment_type") != JSONObject.NULL)
                checkoutOptions.setPaymentType(String.valueOf(options.get("payment_type")));
            if (options.get("amount") != JSONObject.NULL)
                checkoutOptions.setAmount(String.valueOf(options.get("amount")));
            if (options.get("currency") != JSONObject.NULL)
                checkoutOptions.setCurrency(String.valueOf(options.get("currency")));

            if (options.get("customerMobile") != JSONObject.NULL)
                checkoutOptions.setCustomerMobile(String.valueOf(options.get("customerMobile")));
            if (options.get("customerAddressLine1") != JSONObject.NULL)
                checkoutOptions.setCustomerAddressLine1(String.valueOf(options.get("customerAddressLine1")));
            if (options.get("customerAddressLine2") != JSONObject.NULL)
                checkoutOptions.setCustomerAddressLine2(String.valueOf(options.get("customerAddressLine2")));
            if (options.get("customerCity") != JSONObject.NULL)
                checkoutOptions.setCustomerCity(String.valueOf(options.get("customerCity")));
            if (options.get("customerRegion") != JSONObject.NULL)
                checkoutOptions.setCustomerRegion(String.valueOf(options.get("customerRegion")));
            if (options.get("customerCountry") != JSONObject.NULL)
                checkoutOptions.setCustomerCountry(String.valueOf(options.get("customerCountry")));
            if (options.get("customerPostalCode") != JSONObject.NULL)
                checkoutOptions.setCustomerPostalCode(String.valueOf(options.get("customerPostalCode")));
            if (options.get("label") != JSONObject.NULL)
                checkoutOptions.setLabel(String.valueOf(options.get("label")));
            if (options.get("receiverName") != JSONObject.NULL)
                checkoutOptions.setReceiverName(String.valueOf(options.get("receiverName")));
            if (options.get("receiverPhone") != JSONObject.NULL)
                checkoutOptions.setReceiverPhone(String.valueOf(options.get("receiverPhone")));
            if (options.get("landmark") != JSONObject.NULL)
                checkoutOptions.setLandmark(String.valueOf(options.get("landmark")));

            if (options.get("themeColor") != JSONObject.NULL)
                checkoutOptions.setThemeColor(String.valueOf(options.get("themeColor")));
            if (options.get("accentColor") != JSONObject.NULL)
                checkoutOptions.setAccentColor(String.valueOf(options.get("accentColor")));

            if(options.get("darkMode") != JSONObject.NULL) {
                String darkModeValue = String.valueOf(options.get("darkMode"));
                Boolean isDarkModeSet = darkModeValue.toLowerCase() == "true";
                checkoutOptions.setDarkMode(isDarkModeSet);
            }

        } catch (JSONException e) {
            e.printStackTrace();
        }
    }
}
