//
//  Helper.swift
//  dpay_flutter
//
//  Created by user170390 on 6/15/21.
//

import Foundation

/*
 function to get values from options dictionary
 params:
    options - dictionary with checkout options
    key - key of dicitionary to get value
 */
func getCheckoutOptions(
    options: NSMutableDictionary,
    key: String) -> String {
    
    if let object = options.object(forKey: key) as? NSObject,
       String(describing: object) != "" ,
       !object.isEqual(NSNull()) {
        
        return String(describing: object)
    }
    return ""
}

//extension to add additional functions to the UIApplication class
extension UIApplication {
    
    //return the top most view controller in the stack, else, return root view controller
    class func topViewController(_ viewController: UIViewController? = UIApplication.shared.keyWindow?.rootViewController) -> UIViewController? {
        if let nav = viewController as? UINavigationController {
            return topViewController(nav.visibleViewController)
        }
        if let tab = viewController as? UITabBarController {
            if let selected = tab.selectedViewController {
                return topViewController(selected)
            }
        }
        if let presented = viewController?.presentedViewController {
            return topViewController(presented)
        }
        return viewController
    }
    
    //return the top navigation controller in the stack
    class func topNavigationController(_ viewController: UIViewController? = UIApplication.shared.keyWindow?.rootViewController) -> UINavigationController? {
        
        if let nav = viewController as? UINavigationController {
            return nav
        }
        if let tab = viewController as? UITabBarController {
            if let selected = tab.selectedViewController {
                return selected.navigationController
            }
        }
        return viewController?.navigationController
    }
}
