import 'dart:collection';

class WebResourceHelper {
  HashMap hashMap = new HashMap<String, String>();
  WebResourceHelper() {
    hashMap['cssChildDir'] = "css_data";
    hashMap['jsChildDir'] = "js_data";
    hashMap['pngChildDir'] = "image_data";
    hashMap['jpgChildDir'] = "image_data";
    hashMap['svgChildDir'] = "svg_data";

    hashMap['cssMime'] = "text/css";
    hashMap['jsMime'] = "text/javascript";
    hashMap['pngMime'] = "image/png";
    hashMap['jpgMime'] = "image/jpeg";
    hashMap['svgMime'] = "image/svg+xml";
  }

  String? getLocalChild(String url) {
    String fileNameForUrl = getLocalFileNameForUrl(url);
    String fileExt = getFileExt(fileNameForUrl);
    String key = fileExt + "ChildDir";
    return hashMap[key];
  }

  String? getMimeType(String fileExtension) {
    String key = fileExtension + "Mime";
    return hashMap[key];
  }

  static String getFileExt(String fileName) {
    return fileName.substring(fileName.lastIndexOf(".") + 1, fileName.length);
  }

  static String getLocalFileNameForUrl(String url) {
    String localFileName = "";
    var parts = url.split("/");
    if (parts.length > 0) {
      localFileName = parts[parts.length - 1];
    }
    return localFileName;
  }
}
